<?php

require_once('database.inc');
require_once('drupal.inc');
require_once('functions.inc');
require_once('config.inc');

$id = $_REQUEST['id'];

// If a site was specified, load it, and escape some strings
if ($id) {
  $newslink = load_site($id);
}
// Otherwise, just set some fields defaults
else {
  $newslink->link_limit = 20;
  $newslink->regex = "<a href=\"(.*?)\">(.*?)</a>";
}

// Always do the header & menu
print site_header();
print site_menu();

$edit = $_REQUEST['edit'];
$src = $edit['src'];
if (!$id) {
  $id = $edit['id'];
  if ($edit) {
    // Create an object from the array
    foreach ($edit as $var => $value) {
      $newslink->$var = $value;
    }
  }
}
$op = $edit['op'];

switch ($op) {
 case 'Delete':
   if (del_site($id)) {
     $message = "Site $id deleted";
   }
   break;
 case 'Preview':
   //print var_list($newslink);
   // Fill te message variable with the strings matched.
   $message = find_news($newslink, false); //false means dont save
   break;
 case 'Save':
   $id = save_site($edit);
   $message = "Site <a href=\"" . ourhost() . "/$id\">$src</a> saved";
   break;
}

// Now we need to escape some strings, or it will screw 
$newslink->regex = htmlentities($newslink->regex, ENT_QUOTES);
$newslink->strip = htmlentities($newslink->strip, ENT_QUOTES);
$newslink->keyword = htmlentities($newslink->keyword, ENT_QUOTES);

$output .= "Fill in the fields to setup a new html2rss conversion<br />";

$output .= "<form method=\"post\" action=\"edit.php\">\n";
$output .= "<table>";

if ($id) {
  $output .= hidden_field("Id", 'id', $id);
}

$output .= text_field("source category", 20, 'cat', $newslink->cat);
$output .= text_field("source name", 50, 'src', $newslink->src);
$output .= text_field("source url", 80, 'url', $newslink->url);
$output .= text_field("regex", 80, 'regex', $newslink->regex);
$output .= text_field("href id", 2, 'href', $newslink->href);
$output .= text_field("title id", 2, 'title', $newslink->title);
$output .= text_field("text id", 2, 'text', $newslink->text);
$output .= text_field("keyword", 20, 'keyword', $newslink->keyword);
$output .= text_field("strip", 50, 'strip', $newslink->strip);
$output .= text_field("base url", 50, 'base_url', $newslink->base_url);
$output .= text_field("limit", 2, 'link_limit', $newslink->link_limit);

$output .= "</table>";
$output .= "<input type=\"submit\" name=\"edit[op]\" value=\"Save\">";
$output .= "<input type=\"submit\" name=\"edit[op]\" value=\"Preview\">";

if ($id) {
  $output .= "<input type=\"submit\" name=\"edit[op]\" value=\"Delete\">";
}

$output .= "</form><p>";

if ($message) {
  $output .= $message;
}

print $output;

?>
</body>
</html>
